Unit SF73R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SF73R(X :Real; GRAN1 :Real; GRAN2 :Real; var PROB :Real);

implementation

procedure SF73R(X :Real; GRAN1 :Real; GRAN2 :Real; var PROB :Real);
var
GRX,RAB,RAB1,RAS,XGR :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
RAB  := GRAN1 - GRAN2;
RAB1  := RAB*RAB;
RAS  := (GRAN1 + GRAN2)/2.0;
if ( RAB ) < 0
 then goto _10
 else if ( RAB ) > 0
       then goto _50
       else goto _40;
_10:

{      GRAN1.LT.GRAN2 }

if ( X  >  GRAN1 ) 
 then goto _20;
goto _80;
_20:

{      X.GT.GRAN1 (EBO PAH) }

if ( X  >  RAS ) 
 then goto _30;
GRX  := X - GRAN1;
PROB  := 2.0*GRX*GRX/RAB1;
goto _100;
_30:
if ( X  >=  GRAN2 ) 
 then goto _90;

{      (A+B)/2.LT.X.LT.B }

GRX  := GRAN2 - X;
PROB  := 1.0 - 2.0*GRX*GRX/RAB1;
goto _100;
_40:

{      GRAN1=GRAN2 }

PROB  := 0.0;
goto _100;
_50:

{      GRAN1.GT.GRAN2 }

if ( X  >  GRAN2 ) 
 then goto _60;
goto _80;
_60:
if ( X  >  RAS ) 
 then goto _70;
XGR  := X - GRAN2;
PROB  := 2.0*XGR*XGR/RAB1;
goto _100;
_70:
if ( X  >=  GRAN1 ) 
 then goto _90;
XGR  := GRAN1 - X;
PROB  := 1.0 - 2.0*XGR*XGR/RAB1;
goto _100;
_80:

{      X MEHE  PABEH EBO PAH }

PROB  := 0;
goto _100;
_90:

{      X.GE.PABO PAH }

PROB  := 1;
_100:
end;

end.
